/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Text;


public class Evento extends Composite {
	private Composite compositeContenido;
	private Group groupEvaluacion = null;
	private Group groupCitaTutores = null;
	private Group groupCCEscolar = null;
	private Group groupOtro = null;
	private Label labelTipo = null;
	private Label labelFecha = null;
	private Label labelDosPuntos = null;
	private Label labelSumario = null;
	private Label labelPreparativos = null;
	private Label labelConclusion = null;
	private Label labelEvaluacionClase = null;
	private Label labelCitaTutoresRelacion = null;
	private Text textCitaTutoresRelacion = null;public Text getTextCitaTutoresRelacion(){return textCitaTutoresRelacion;}
	private Text textAreaSumario = null;public Text getTextAreaSumario(){return textAreaSumario;}
	private Text textAreaPreparativos = null;public Text getTextAreaPreparativos(){return textAreaPreparativos;}
	private Text textAreaConclusion = null;public Text getTextAreaConclusion(){return textAreaConclusion;}
	private Text textAreaEvaluacionDescripcion = null;public Text getTextAreaEvaluacionDescripcion(){return textAreaEvaluacionDescripcion;}
	private Text textAreaOtroDescripcion = null;public Text getTextAreaOtroDescripcion(){return textAreaOtroDescripcion;}
	private Combo comboEvaluacionClase = null;
	private Combo comboFecha = null;
	private Combo comboHoras = null;
	private Combo comboMinutos = null;
	private Combo comboTipo = null;
	private ComboConId comboConIdTipo = null;
	private FechaCombo fechaComboFecha = null;public FechaCombo getFechaComboFecha(){return this.fechaComboFecha;};
	private MinutoCombo minutoComboMinutos = null;
	private HoraCombo horaComboHoras = null;
	private List listEventos = null;
	private List listCitaTutoresEstudiantes = null;
	private ListConId listConIdEventos = null;  //  @jve:decl-index=0:
	private Button buttonNuevo = null;
	private Button buttonBorrar = null;
	private Button radioButtonCCEOrdinario = null;
	private Button radioButtonCCEExtraordinario = null;
	private Button checkBoxPasado = null;
	private ComboConId comboConIdClase;
	private ListConId listConIdCitaTutoresEstudiantes;
	public Evento(Composite parent, int style) {super(parent, style);initialize();}
	public void actualizar(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		comboConIdClase.rellenarClases(null,null,null);
		listConIdCitaTutoresEstudiantes.rellenaListConIdTutoria();
		actualizarTipo();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() end");
	}
	private void initialize() {
		GridLayout gridLayoutCompositeEvento = new GridLayout();
		gridLayoutCompositeEvento.horizontalSpacing = 2;
		gridLayoutCompositeEvento.verticalSpacing = 2;
		gridLayoutCompositeEvento.marginWidth = 2;
		gridLayoutCompositeEvento.marginHeight = 2;
		gridLayoutCompositeEvento.numColumns = 2;
		GridData gridDataCompositeEvento = new GridData();
		gridDataCompositeEvento.grabExcessHorizontalSpace = true;
		gridDataCompositeEvento.grabExcessVerticalSpace = true;
		gridDataCompositeEvento.horizontalAlignment = GridData.FILL;
		gridDataCompositeEvento.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataCompositeEvento);
		this.setLayout(gridLayoutCompositeEvento);
		this.setSize(new Point(685, 340));
		createGroupContenido();
		createGroupEvaluacion();
		createGroupCitaTutores();
		createGroupClaustroCEscolar();
		createGroupOtro();
		actualizarTipo();
	}
	private void createGroupAcciones() {
	}
	private void createGroupContenido() {
		GridLayout gl_compositeContenido = new GridLayout();
		gl_compositeContenido.horizontalSpacing = 2;
		gl_compositeContenido.marginWidth = 2;
		gl_compositeContenido.marginHeight = 2;
		gl_compositeContenido.verticalSpacing = 2;
		GridData gd_compositeContenido = new GridData();
		gd_compositeContenido.verticalAlignment = GridData.FILL;
		gd_compositeContenido.grabExcessHorizontalSpace = true;
		gd_compositeContenido.grabExcessVerticalSpace = true;
		gd_compositeContenido.verticalSpan = 4;
		gd_compositeContenido.horizontalAlignment = GridData.FILL;
		compositeContenido = new Composite(this, SWT.NONE);
		compositeContenido.setLayoutData(gd_compositeContenido);
		compositeContenido.setLayout(gl_compositeContenido);
		createComboTipo();
		createGroupAcciones();
		GridData gridDataListEventos = new GridData();
		gridDataListEventos.horizontalAlignment = GridData.FILL;
		gridDataListEventos.verticalAlignment = GridData.FILL;
		gridDataListEventos.heightHint = 75;
		gridDataListEventos.grabExcessVerticalSpace = true;
		gridDataListEventos.grabExcessHorizontalSpace = true;
		listEventos = new List(compositeContenido, SWT.V_SCROLL|SWT.BORDER);
		listEventos.setLayoutData(gridDataListEventos);
		listEventos.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ListEventos_ToolTip"));
		listEventos.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Selecting Event");
				//System.out.println("Actualizando Datos del evento seleccionado "+listEventos.getSelectionIndex()+".");
				actualizarDatosEvento();
			}
		});
		listConIdEventos = new ListConId(listEventos);
		createComboFecha();
		createComboHora();
		createComboMinuto();
		GridData gridDataLabelSumario = new GridData();
		gridDataLabelSumario.horizontalAlignment = GridData.FILL;
		gridDataLabelSumario.verticalAlignment = GridData.END;
		labelSumario = new Label(compositeContenido, SWT.HORIZONTAL);
		labelSumario.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_LabelSumario_Text"));
		labelSumario.setLayoutData(gridDataLabelSumario);
		GridData gridDataTextAreaSumario = new GridData();
		gridDataTextAreaSumario.minimumHeight = 25;
		gridDataTextAreaSumario.horizontalAlignment = GridData.FILL;
		gridDataTextAreaSumario.grabExcessVerticalSpace = true;
		gridDataTextAreaSumario.grabExcessHorizontalSpace = true;
		gridDataTextAreaSumario.heightHint = 50;
		gridDataTextAreaSumario.verticalSpan = 1;
		gridDataTextAreaSumario.verticalAlignment = GridData.FILL;
		textAreaSumario = new Text(compositeContenido, SWT.WRAP|SWT.MULTI|SWT.BORDER|SWT.V_SCROLL);
		textAreaSumario.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_TextAreaSumario_ToolTip"));
		textAreaSumario.setLayoutData(gridDataTextAreaSumario);
		TextoDemorado.add(textAreaSumario,false,1024,null,null,true,listConIdEventos,null);
		GridData gridDataLabelPreparativos = new GridData();
		gridDataLabelPreparativos.horizontalAlignment = GridData.FILL;
		gridDataLabelPreparativos.grabExcessVerticalSpace = false;
		gridDataLabelPreparativos.verticalAlignment = GridData.END;
		labelPreparativos = new Label(compositeContenido, SWT.NONE);
		labelPreparativos.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_LabelPreparitivos_Text"));
		labelPreparativos.setLayoutData(gridDataLabelPreparativos);
		GridData gridDataTextAreaPreparativos = new GridData();
		gridDataTextAreaPreparativos.minimumHeight = 25;
		gridDataTextAreaPreparativos.horizontalAlignment = GridData.FILL;
		gridDataTextAreaPreparativos.grabExcessVerticalSpace = true;
		gridDataTextAreaPreparativos.grabExcessHorizontalSpace = true;
		gridDataTextAreaPreparativos.heightHint = 50;
		gridDataTextAreaPreparativos.verticalAlignment = GridData.FILL;
		textAreaPreparativos = new Text(compositeContenido,SWT.WRAP|SWT.MULTI|SWT.BORDER|SWT.V_SCROLL);
		textAreaPreparativos.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_TextAreaPreparitivos_ToolTip"));
		textAreaPreparativos.setLayoutData(gridDataTextAreaPreparativos);
		TextoDemorado.add(textAreaPreparativos,false,512,null,null,true,listConIdEventos,null);
		GridData gridDataLabelConclusion = new GridData();
		gridDataLabelConclusion.horizontalAlignment = GridData.FILL;
		gridDataLabelConclusion.verticalAlignment = GridData.END;
		labelConclusion = new Label(compositeContenido, SWT.NONE);
		labelConclusion.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_LabelConclusion_Text"));
		labelConclusion.setLayoutData(gridDataLabelConclusion);
		GridData gridDataTextAreaConclusion = new GridData();
		gridDataTextAreaConclusion.minimumHeight = 25;
		gridDataTextAreaConclusion.horizontalAlignment = GridData.FILL;
		gridDataTextAreaConclusion.grabExcessVerticalSpace = true;
		gridDataTextAreaConclusion.grabExcessHorizontalSpace = true;
		gridDataTextAreaConclusion.heightHint = 50;
		gridDataTextAreaConclusion.verticalAlignment = GridData.FILL;
		textAreaConclusion = new Text(compositeContenido, SWT.WRAP|SWT.MULTI|SWT.BORDER|SWT.V_SCROLL);
		textAreaConclusion.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_TextAreaConclusion_ToolTip"));
		textAreaConclusion.setLayoutData(gridDataTextAreaConclusion);
		TextoDemorado.add(textAreaConclusion,false,512,null,null,true,listConIdEventos,null);
	}

	private void createComboTipo() {
		
		Composite composite = new Composite(compositeContenido, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite = new GridLayout(5, false);
		gl_composite.horizontalSpacing = 2;
		gl_composite.marginHeight = 2;
		gl_composite.marginWidth = 2;
		gl_composite.verticalSpacing = 2;
		composite.setLayout(gl_composite);
		labelTipo = new Label(composite, SWT.NONE);
		labelTipo.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		labelTipo.setText("Tipo:");
		comboTipo = new Combo(composite, SWT.READ_ONLY);
		GridData gd_comboTipo = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboTipo.widthHint = 100;
		comboTipo.setLayoutData(gd_comboTipo);
		comboTipo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ComboTipo_Text"));
		comboTipo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ComboTipo_ToolTip"));
		comboTipo
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Change event type");
						actualizarListaEventos(null);
						listConIdEventos.fijarFoco();
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		comboConIdTipo = new ComboConId(comboTipo);
		checkBoxPasado = new Button(composite, SWT.CHECK);
		checkBoxPasado.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_CheckBoxPasado_ToolTip"));
		checkBoxPasado.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_CheckBoxPasado_Text"));
		checkBoxPasado.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Activate/Deactivate last");
				actualizarListaEventos(null);
				listConIdEventos.fijarFoco();
			}
		});
		buttonNuevo = new Button(composite, SWT.NONE);
		buttonNuevo.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		buttonNuevo.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ButtonNuevo_Text"));
		buttonNuevo.setEnabled(false);
		buttonNuevo.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ButtonNuevo_ToolTip"));
		buttonNuevo
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Making Events");
						String claseTutoria = BBDD.consultarIdClaseTutoria(BBDD.consultarIdPropio());
						Vector<Vector<String>> clases = BBDD.consultarClase(null, null);
						Vector<Vector<String>> estudiantes = BBDD.consultarEstudiantesTutoriaProfesor(BBDD.consultarIdPropio());
						if (estudiantes!=null) if (estudiantes.size()==0) estudiantes=null;
						if (clases!=null) if (clases.size()==0) clases=null;
						if (Integer.parseInt(comboConIdTipo.idSeleccionado())==BBDD.idTipoCitaConTutores && claseTutoria==null)
							PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ButtonNuevo_Error_NoClassTutor"));
						else if (Integer.parseInt(comboConIdTipo.idSeleccionado())==BBDD.idTipoEvaluacion && clases==null)
							PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ButtonNuevo_Error_NoClass"));
						else if (Integer.parseInt(comboConIdTipo.idSeleccionado())==BBDD.idTipoCitaConTutores && estudiantes==null)
							PCuaderno.MiPCuaderno.error(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ButtonNuevo_Error_NoStudents"));
						else {
							Calendar fecha=((Integer.valueOf(comboConIdTipo.idSeleccionado())!=BBDD.idTipoOtroTipo)?Fecha.diaLaboralOSiguiente(Fecha.fechaDeTrabajo, false):Fecha.fechaDeTrabajo);
							String id=BBDD.insertarEvento(Integer.parseInt(comboConIdTipo.idSeleccionado()),fecha);
							if (fecha.compareTo(Calendar.getInstance())<0) checkBoxPasado.setSelection(true);
							actualizarListaEventos(id);
							PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(fecha);
							textAreaSumario.setFocus();
						}
					}
				});
		buttonBorrar = new Button(composite, SWT.NONE);
		buttonBorrar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ButtonBorrar_Text"));
		buttonBorrar.setEnabled(false);
		buttonBorrar.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ButtonBorrar_ToolTip"));
		buttonBorrar
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Deleting Event");
						Vector<Vector<String>> evento = new Vector<Vector<String>>();
						String id = listConIdEventos.idSeleccionado();
						evento=BBDD.consultarEvento(id);
						Calendar f = Fecha.fecha(evento.get(0).get(1), evento.get(0).get(2), evento.get(0).get(3));
						BBDD.borrarEvento(id);
						PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(f);
						listConIdEventos.seleccionarSiguienteOAnterior();
						actualizarListaEventos(null);
						listConIdEventos.fijarFoco();
					}
				});
	}
	private void createComboFecha(){
		
		Composite compositeFechaHora = new Composite(compositeContenido, SWT.NONE);
		compositeFechaHora.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_compositeFechaHora = new GridLayout(7, false);
		gl_compositeFechaHora.verticalSpacing = 2;
		gl_compositeFechaHora.marginWidth = 2;
		gl_compositeFechaHora.marginHeight = 2;
		gl_compositeFechaHora.horizontalSpacing = 2;
		compositeFechaHora.setLayout(gl_compositeFechaHora);
		labelFecha = new Label(compositeFechaHora, SWT.NONE);
		labelFecha.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false, 2, 1));
		labelFecha.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_LabelFecha_Text"));
		comboFecha = new Combo(compositeFechaHora,SWT.READ_ONLY);
		GridData gd_comboFecha = new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1);
		gd_comboFecha.widthHint = 100;
		comboFecha.setLayoutData(gd_comboFecha);
		comboFecha.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ComboFecha_ToolTip"));
		comboFecha.setText("aaa 00-aaa-0000");
		comboFecha.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Modifying date");
				if (comboFecha.getSelectionIndex()>=0){
					String idEvento = new String(listConIdEventos.idSeleccionado());
					Vector<Vector<String>> antiguo = BBDD.consultarEvento(idEvento);
					BBDD.modificarFechaEvento(idEvento,fechaComboFecha.fechaSeleccionada());
					actualizarListaEventos(null);
					listConIdEventos.seleccionarId(idEvento);
					PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(Fecha.fecha(antiguo.get(0).get(1),antiguo.get(0).get(2),antiguo.get(0).get(3)));
					PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(fechaComboFecha.fechaSeleccionada());
					Fecha.fechaDeTrabajo=fechaComboFecha.fechaSeleccionada();
				}
			}
			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		fechaComboFecha = new FechaCombo(comboFecha);
		comboHoras = new Combo(compositeFechaHora,SWT.READ_ONLY);
		GridData gd_comboHoras = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboHoras.widthHint = 10;
		comboHoras.setLayoutData(gd_comboHoras);
		comboHoras.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ComboHora_ToolTip"));
		comboHoras.setText("00");
		comboHoras.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Modificando hora");
				if (comboHoras.getSelectionIndex()>=0){
					String idEvento = new String(listConIdEventos.idSeleccionado());
					BBDD.modificarHoraEvento(idEvento,Fecha.hora(horaComboHoras.horaSeleccionada(),minutoComboMinutos.minutoSeleccionada()));
					actualizarListaEventos(null);
					listConIdEventos.seleccionarId(idEvento);
					PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(fechaComboFecha.fechaSeleccionada());
				}
			}
			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		horaComboHoras = new HoraCombo(comboHoras);
		labelDosPuntos = new Label(compositeFechaHora, SWT.NONE);
		labelDosPuntos.setText(":");
		comboMinutos = new Combo(compositeFechaHora,SWT.READ_ONLY);
		comboMinutos.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ComboMinuto_ToolTip"));
		GridData gd_comboMinutos = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboMinutos.widthHint = 10;
		comboMinutos.setLayoutData(gd_comboMinutos);
		comboMinutos.setText("00");
		comboMinutos.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Modifying minute");
				if (minutoComboMinutos.minutoSeleccionada()!=null){
					String idEvento = new String(listConIdEventos.idSeleccionado());
					BBDD.modificarHoraEvento(idEvento,Fecha.hora(horaComboHoras.horaSeleccionada(),minutoComboMinutos.minutoSeleccionada()));
					actualizarListaEventos(null);
					listConIdEventos.seleccionarId(idEvento);
					PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(fechaComboFecha.fechaSeleccionada());
				}
			}
			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		minutoComboMinutos = new MinutoCombo(comboMinutos);
	}
	private void createComboHora(){
	}
	private void createComboMinuto(){
	}
	private void createComboEvaluacionClase() {
		GridData gridDataComboEventosEvaluacionClase = new GridData();
		gridDataComboEventosEvaluacionClase.grabExcessHorizontalSpace = true;
		gridDataComboEventosEvaluacionClase.verticalAlignment = GridData.FILL;
		gridDataComboEventosEvaluacionClase.horizontalAlignment = GridData.FILL;
		comboEvaluacionClase = new Combo(groupEvaluacion,SWT.READ_ONLY);
		comboEvaluacionClase.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ComboEvaluacionClase_ToolTip"));
		comboEvaluacionClase.setLayoutData(gridDataComboEventosEvaluacionClase);
		comboEvaluacionClase
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Modificando clase");
						BBDD.modificarClaseEvaluacion(listConIdEventos.idSeleccionado(),comboConIdClase.idSeleccionado());
						actualizarListaEventos(null);
						PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(fechaComboFecha.fechaSeleccionada());
						textAreaEvaluacionDescripcion.setFocus();
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		comboConIdClase = new ComboConId(comboEvaluacionClase);
		comboConIdClase.rellenarClases(null,null,null);
	}
	private void createGroupEvaluacion() {
		GridLayout gridLayoutGroupEvaluacion = new GridLayout();
		gridLayoutGroupEvaluacion.numColumns = 2;
		gridLayoutGroupEvaluacion.verticalSpacing = 2;
		gridLayoutGroupEvaluacion.marginWidth = 2;
		gridLayoutGroupEvaluacion.marginHeight = 2;
		gridLayoutGroupEvaluacion.horizontalSpacing = 2;
		GridData gridDataGroupEvaluacion = new GridData();
		gridDataGroupEvaluacion.horizontalAlignment = GridData.FILL;
		gridDataGroupEvaluacion.grabExcessVerticalSpace = true;
		gridDataGroupEvaluacion.grabExcessHorizontalSpace = true;
		gridDataGroupEvaluacion.verticalAlignment = GridData.FILL;
		groupEvaluacion = new Group(this, SWT.NONE);
		groupEvaluacion.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_GroupEvaluacion_Text"));
		groupEvaluacion.setEnabled(true);
		groupEvaluacion.setLayout(gridLayoutGroupEvaluacion);
		groupEvaluacion.setLayoutData(gridDataGroupEvaluacion);
		GridData gridDataLabelEvaluacionClase = new GridData();
		gridDataLabelEvaluacionClase.horizontalAlignment = GridData.END;
		gridDataLabelEvaluacionClase.grabExcessHorizontalSpace = false;
		gridDataLabelEvaluacionClase.verticalAlignment = GridData.CENTER;
		labelEvaluacionClase = new Label(groupEvaluacion, SWT.NONE);
		labelEvaluacionClase.setLayoutData(gridDataLabelEvaluacionClase);
		labelEvaluacionClase.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_LabelEvaluacionClase_Text"));
		GridData gridDataTextAreaEvaluacionDescripcion = new GridData();
		gridDataTextAreaEvaluacionDescripcion.horizontalAlignment = GridData.FILL;
		gridDataTextAreaEvaluacionDescripcion.grabExcessHorizontalSpace = true;
		gridDataTextAreaEvaluacionDescripcion.grabExcessVerticalSpace = true;
		gridDataTextAreaEvaluacionDescripcion.heightHint = -1;
		gridDataTextAreaEvaluacionDescripcion.horizontalSpan = 2;
		gridDataTextAreaEvaluacionDescripcion.verticalAlignment = GridData.FILL;
		createComboEvaluacionClase();
		textAreaEvaluacionDescripcion = new Text(groupEvaluacion, SWT.WRAP|SWT.BORDER|SWT.MULTI|SWT.V_SCROLL);
		textAreaEvaluacionDescripcion.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_TextAreaEvaluacionDescripcion_ToolTip"));
		textAreaEvaluacionDescripcion.setText("");
		textAreaEvaluacionDescripcion.setLayoutData(gridDataTextAreaEvaluacionDescripcion);
		TextoDemorado.add(textAreaEvaluacionDescripcion,false,256,null,null,true,listConIdEventos,null);
	}
	private void createGroupCitaTutores() {
		GridLayout gridLayoutGroupCitaTutores = new GridLayout();
		gridLayoutGroupCitaTutores.numColumns = 2;
		gridLayoutGroupCitaTutores.verticalSpacing = 2;
		gridLayoutGroupCitaTutores.marginWidth = 2;
		gridLayoutGroupCitaTutores.horizontalSpacing = 2;
		GridData gridDataGroupCitaTutores = new GridData();
		gridDataGroupCitaTutores.grabExcessHorizontalSpace = false;
		gridDataGroupCitaTutores.grabExcessVerticalSpace = true;
		gridDataGroupCitaTutores.horizontalAlignment = GridData.FILL;
		gridDataGroupCitaTutores.verticalAlignment = GridData.FILL;
		groupCitaTutores = new Group(this, SWT.NONE);
		groupCitaTutores.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_GroupCitaTutores_Text"));
		groupCitaTutores.setLayout(gridLayoutGroupCitaTutores);
		groupCitaTutores.setLayoutData(gridDataGroupCitaTutores);
		GridData gridDataListCitaTutoresEstudiantes = new GridData();
		gridDataListCitaTutoresEstudiantes.horizontalAlignment = GridData.FILL;
		gridDataListCitaTutoresEstudiantes.grabExcessHorizontalSpace = true;
		gridDataListCitaTutoresEstudiantes.grabExcessVerticalSpace = true;
		gridDataListCitaTutoresEstudiantes.heightHint = 50;
		gridDataListCitaTutoresEstudiantes.horizontalSpan = 2;
		gridDataListCitaTutoresEstudiantes.verticalAlignment = GridData.FILL;
		listCitaTutoresEstudiantes = new List(groupCitaTutores, SWT.V_SCROLL|SWT.MULTI|SWT.BORDER);
		listCitaTutoresEstudiantes.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_ListCitaTutoresEstudiantes_ToolTip"));
		listCitaTutoresEstudiantes.setLayoutData(gridDataListCitaTutoresEstudiantes);
		listCitaTutoresEstudiantes
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Modifying students");
						BBDD.modificarEstudiantesCitaTutor(listConIdEventos.idSeleccionado(),listConIdCitaTutoresEstudiantes.idSeleccionados());
						actualizarListaEventos(null);
						PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(fechaComboFecha.fechaSeleccionada());
						listCitaTutoresEstudiantes.setFocus();
					}
				});
		listConIdCitaTutoresEstudiantes = new ListConId(listCitaTutoresEstudiantes);
		labelCitaTutoresRelacion = new Label(groupCitaTutores, SWT.NONE);
		labelCitaTutoresRelacion.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_LabelCitaTutoresRelacion_Text"));
		GridData gridDataTextCitaTutoresRelacion = new GridData();
		gridDataTextCitaTutoresRelacion.grabExcessHorizontalSpace = true;
		gridDataTextCitaTutoresRelacion.horizontalAlignment = GridData.FILL;
		gridDataTextCitaTutoresRelacion.verticalAlignment = GridData.FILL;
		gridDataTextCitaTutoresRelacion.grabExcessVerticalSpace = false;
		textCitaTutoresRelacion = new Text(groupCitaTutores, SWT.BORDER);
		textCitaTutoresRelacion.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_TextCitaTutoresRelacion_ToolTip"));
		textCitaTutoresRelacion.setLayoutData(gridDataTextCitaTutoresRelacion);
		TextoDemorado.add(textCitaTutoresRelacion,false,256,null,null,true,listConIdEventos,null);
	}
	private void createGroupClaustroCEscolar() {
		GridLayout gridLayoutGroupCCEscolar = new GridLayout();
		gridLayoutGroupCCEscolar.numColumns = 2;
		gridLayoutGroupCCEscolar.marginWidth = 5;
		gridLayoutGroupCCEscolar.verticalSpacing = 2;
		gridLayoutGroupCCEscolar.horizontalSpacing = 2;
		gridLayoutGroupCCEscolar.marginHeight = 2;
		GridData gridDataGroupCCEscolar = new GridData();
		gridDataGroupCCEscolar.grabExcessHorizontalSpace = false;
		gridDataGroupCCEscolar.grabExcessVerticalSpace = false;
		gridDataGroupCCEscolar.horizontalAlignment = GridData.FILL;
		gridDataGroupCCEscolar.verticalAlignment = GridData.CENTER;
		groupCCEscolar = new Group(this, SWT.NONE);
		groupCCEscolar.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_GroupCCEscolar_Text"));
		groupCCEscolar.setLayout(gridLayoutGroupCCEscolar);
		groupCCEscolar.setLayoutData(gridDataGroupCCEscolar);
		radioButtonCCEOrdinario = new Button(groupCCEscolar, SWT.RADIO);
		radioButtonCCEOrdinario.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_RadioButtonCCEOrdinario_Text"));
		radioButtonCCEOrdinario
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Modifying Ordinary");
						//System.out.println("ordinario "+((radioButtonCCEOrdinario.getSelection())?"Seleccionado":"No seleccionado"));
						BBDD.modificarOrdinarioEvento(listConIdEventos.idSeleccionado(),radioButtonCCEOrdinario.getSelection());
						actualizarListaEventos(null);
						PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(fechaComboFecha.fechaSeleccionada());
						listConIdEventos.fijarFoco();
					}
				});
		radioButtonCCEExtraordinario = new Button(groupCCEscolar, SWT.RADIO);
		radioButtonCCEExtraordinario.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_RadioButtonCCEExtraordinario_Text"));
	}
	private void createGroupOtro() {
		GridLayout gridLayoutGroupOtro = new GridLayout();
		gridLayoutGroupOtro.numColumns = 1;
		gridLayoutGroupOtro.verticalSpacing = 2;
		gridLayoutGroupOtro.marginWidth = 2;
		gridLayoutGroupOtro.marginHeight = 2;
		gridLayoutGroupOtro.horizontalSpacing = 2;
		GridData gridDataGroupOtro = new GridData();
		gridDataGroupOtro.verticalAlignment = GridData.FILL;
		gridDataGroupOtro.grabExcessHorizontalSpace = false;
		gridDataGroupOtro.grabExcessVerticalSpace = true;
		gridDataGroupOtro.horizontalAlignment = GridData.FILL;
		groupOtro = new Group(this, SWT.NONE);
		groupOtro.setText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_GroupOtro_Text"));
		groupOtro.setLayout(gridLayoutGroupOtro);
		groupOtro.setLayoutData(gridDataGroupOtro);
		GridData gridDataTextAreaOtroDescripcion = new GridData();
		gridDataTextAreaOtroDescripcion.minimumHeight = 25;
		gridDataTextAreaOtroDescripcion.horizontalAlignment = GridData.FILL;
		gridDataTextAreaOtroDescripcion.verticalAlignment = GridData.FILL;
		gridDataTextAreaOtroDescripcion.grabExcessHorizontalSpace = true;
		gridDataTextAreaOtroDescripcion.grabExcessVerticalSpace = true;
		gridDataTextAreaOtroDescripcion.heightHint = -1;
		textAreaOtroDescripcion = new Text(groupOtro, SWT.WRAP|SWT.MULTI|SWT.BORDER|SWT.V_SCROLL);
		textAreaOtroDescripcion.setToolTipText(PCuaderno.MiPCuaderno.mensajes.getString("Eventos_TextAreaOtroDescripcion_ToolTip"));
		textAreaOtroDescripcion.setText("");
		textAreaOtroDescripcion.setLayoutData(gridDataTextAreaOtroDescripcion);
		TextoDemorado.add(textAreaOtroDescripcion,false,256,null,null,true,listConIdEventos,null);
	}
	public void actualizarTipo(){
		//System.out.println("Actualizado "+comboConIdEventosTipo.getObjetoCombo().getItemCount()+"/"+comboConIdEventosTipo.getIdentificadores().size()+" Tipos de Eventos. Id del seleccionado "+comboConIdEventosTipo.idSeleccionado());
		comboConIdTipo.rellenarTipoEvento();
		actualizarListaEventos(null);
	}
	private void actualizarListaEventos(String idSeleccionado){
		Vector<Vector<String>> eventos;
		Vector<Vector<String>> eventoTipo;
		if (idSeleccionado==null) idSeleccionado=String.valueOf(listConIdEventos.idSeleccionado());
		listConIdEventos.borrar();
		if (comboConIdTipo.idSeleccionado()!=null){
			eventos=BBDD.consultarEventosTipoDesdeFecha(comboConIdTipo.idSeleccionado(),((!checkBoxPasado.getSelection())?Fecha.fechaHoraCero(Calendar.getInstance()):null));
			String info;
			for (int i=0;i<eventos.size();i++){
				Calendar fecha=null;
				fecha=Fecha.fechaHora(eventos.get(i).get(1),eventos.get(i).get(2),eventos.get(i).get(3),eventos.get(i).get(4),eventos.get(i).get(5));
				//System.out.println("Dia evento ("+eventos.get(i).get(0)+"): "+Fecha.formaFechaDiaHora(fecha)+" info="+eventos.get(i).get(9));
				info=Fecha.formaFechaDiaHora(fecha)+" ";
				eventoTipo=BBDD.consultarEventoTipoDatos(eventos.get(i).get(0),Integer.parseInt(eventos.get(i).get(9)));
				if (eventoTipo!=null) if (eventoTipo.size()>0) {
					if (Integer.parseInt(eventos.get(i).get(9))==BBDD.idTipoEvaluacion) {
						info+=" "+eventos.get(i).get(10)+" "+eventoTipo.get(0).get(3)+PCuaderno.MiPCuaderno.mensajes.getString("Ordinal")+eventoTipo.get(0).get(4)+" "+eventoTipo.get(0).get(5);
						//info+=" "+eventoTipo.get(0).get(5)+", "+eventoTipo.get(0).get(6);
					} else if (Integer.parseInt(eventos.get(i).get(9))==BBDD.idTipoClaustro) {
						info+=" "+eventos.get(i).get(10)+" "+((eventoTipo.get(0).get(1).equals(BBDD.verdadero))?BBDD.expOrdinario:BBDD.expExtraordinario);
					} else if (Integer.parseInt(eventos.get(i).get(9))==BBDD.idTipoConsejoEscolar) {
						info+=" "+eventos.get(i).get(10)+" "+((eventoTipo.get(0).get(1).equals(BBDD.verdadero))?BBDD.expOrdinario:BBDD.expExtraordinario);
					} else if (Integer.parseInt(eventos.get(i).get(9))==BBDD.idTipoETCP) {
						info+=" "+eventos.get(i).get(10);
					} else if (Integer.parseInt(eventos.get(i).get(9))==BBDD.idTipoCitaConTutores) {
						info+=" "+eventos.get(i).get(10);
						//info+=" ("+eventoTipo.get(0).get(1)+")";
						Vector<Vector<String>> estudiantes = BBDD.consultarEstudiantesCitaTutores(eventos.get(i).get(0));
						if (estudiantes.size()>0){
							info+=" ("+estudiantes.get(0).get(1)+", "+estudiantes.get(0).get(2)+((estudiantes.size()>1)?";...":"")+")";
						}
					} else if (Integer.parseInt(eventos.get(i).get(9))==BBDD.idTipoOtroTipo) {
						info+=" "+eventos.get(i).get(10);
					}
				} else {
					info+=" wihtout type asosiated (Error)";
				}
				listConIdEventos.addElemento(eventos.get(i).get(0),info);
			}
			listConIdEventos.seleccionarId(idSeleccionado);
			//System.out.println("["+idSeleccionado+"] Actualizado "+listConIdEventos.getObjetoList().getItemCount()+"/"+listConIdEventos.getIdentificadores().size()+" Eventos. Id del seleccionado "+listConIdEventos.idSeleccionado());
			actualizarDatosEvento();
		}
		if (comboTipo.getSelectionIndex()==0){
			buttonNuevo.setEnabled(false);
		} else {
			buttonNuevo.setEnabled(true);
		}
	}
	private void actualizarDatosEvento(){
		Vector<Vector<String>> evento;
		Vector<Vector<String>> eventoTipo;
		TextoDemorado.escribeSiHay();
		if (groupEvaluacion.getEnabled()){
			for (int i=0;i<groupEvaluacion.getChildren().length;i++){
				groupEvaluacion.getChildren()[i].setEnabled(false);
				if (groupEvaluacion.getChildren()[i].getClass().getName().equals("org.eclipse.swt.widgets.Text"))
					((Text)groupEvaluacion.getChildren()[i]).setText("");
				if (groupEvaluacion.getChildren()[i].getClass().getName().equals("org.eclipse.swt.widgets.Combo"))
					((Combo)groupEvaluacion.getChildren()[i]).setText("");
			}
			groupEvaluacion.setEnabled(false);
		}
		if (groupCitaTutores.getEnabled()){
			for (int i=0;i<groupCitaTutores.getChildren().length;i++){
				groupCitaTutores.getChildren()[i].setEnabled(false);
				if (groupCitaTutores.getChildren()[i].getClass().getName().equals("org.eclipse.swt.widgets.Text"))
					((Text)groupCitaTutores.getChildren()[i]).setText("");
				if (groupCitaTutores.getChildren()[i].getClass().getName().equals("org.eclipse.swt.widgets.List"))
					((List)groupCitaTutores.getChildren()[i]).setSelection(-1);
			}
			groupCitaTutores.setEnabled(false);
		}
		if (groupCCEscolar.getEnabled()){
			for (int i=0;i<groupCCEscolar.getChildren().length;i++){
				groupCCEscolar.getChildren()[i].setEnabled(false);
				if (groupCCEscolar.getChildren()[i].getClass().getName().equals("org.eclipse.swt.widgets.Button"))
					((Button)groupCCEscolar.getChildren()[i]).setSelection(false);
			}
			groupCCEscolar.setEnabled(false);
		}
		if (groupOtro.getEnabled()){
			for (int i=0;i<groupOtro.getChildren().length;i++){
				groupOtro.getChildren()[i].setEnabled(false);
				if (groupOtro.getChildren()[i].getClass().getName().equals("org.eclipse.swt.widgets.Text"))
					((Text)groupOtro.getChildren()[i]).setText("");
			}
			groupOtro.setEnabled(false);
		}
		if (listConIdEventos.idSeleccionado()==null){
			TextoDemorado.modificaSinActualizar(textAreaSumario,"");
			TextoDemorado.modificaSinActualizar(textAreaPreparativos,"");
			TextoDemorado.modificaSinActualizar(textAreaConclusion,"");
			fechaComboFecha.borrar();
			horaComboHoras.borrar();
			minutoComboMinutos.borrar();	
		} else {
			evento=BBDD.consultarEvento(listConIdEventos.idSeleccionado());
			TextoDemorado.modificaSinActualizar(textAreaSumario,evento.get(0).get(6));
			TextoDemorado.modificaSinActualizar(textAreaPreparativos,evento.get(0).get(7));
			TextoDemorado.modificaSinActualizar(textAreaConclusion,evento.get(0).get(8));
			if (Integer.parseInt(evento.get(0).get(9))==BBDD.idTipoOtroTipo){
				//System.out.println("Rellenando Fecha y horas para tipo OtroTipo de evento");
				fechaComboFecha.rellenarDesdeFecha(((!checkBoxPasado.getSelection())?Fecha.fechaHoraCero(Calendar.getInstance()):null));
				horaComboHoras.rellenaComboTodas();
			} else {
				//System.out.println("Rellenando Fecha y horas para tipo "+evento.get(0).get(9)+" de evento");
				fechaComboFecha.rellenarLectivosParcialDesdeFechaMateria(null,((!checkBoxPasado.getSelection())?Fecha.fechaHoraCero(Calendar.getInstance()):null),false);
				horaComboHoras.rellenaComboLaborales();
			}
			//System.out.println(evento.get(0).get(1)+"/"+ evento.get(0).get(2)+"/"+ evento.get(0).get(3)+" "+ evento.get(0).get(4)+":"+ evento.get(0).get(5));
			fechaComboFecha.seleccionarFecha(Fecha.fecha(evento.get(0).get(1), evento.get(0).get(2), evento.get(0).get(3)));
			horaComboHoras.seleccionarHora(evento.get(0).get(4));
			minutoComboMinutos.rellena();
			minutoComboMinutos.seleccionarMinuto(evento.get(0).get(5));

			eventoTipo=BBDD.consultarEventoTipoDatos(evento.get(0).get(0),Integer.parseInt(evento.get(0).get(9)));
			if (eventoTipo!=null) if (eventoTipo.size()>0) {
				if (Integer.parseInt(evento.get(0).get(9))==BBDD.idTipoEvaluacion) {
					groupEvaluacion.setEnabled(true);
					textAreaEvaluacionDescripcion.setText(eventoTipo.get(0).get(1));
					comboConIdClase.seleccionarId(eventoTipo.get(0).get(2));
					for (int i=0;i<groupEvaluacion.getChildren().length;i++)
						groupEvaluacion.getChildren()[i].setEnabled(true);
				} else if(Integer.parseInt(evento.get(0).get(9))==BBDD.idTipoClaustro || Integer.parseInt(evento.get(0).get(9))==BBDD.idTipoConsejoEscolar) {
					groupCCEscolar.setEnabled(true);
					if (eventoTipo.get(0).get(1).equals(BBDD.verdadero)){
						radioButtonCCEOrdinario.setSelection(true);
						radioButtonCCEExtraordinario.setSelection(false);
					} else {
						radioButtonCCEOrdinario.setSelection(false);
						radioButtonCCEExtraordinario.setSelection(true);
					}
					for (int i=0;i<groupCCEscolar.getChildren().length;i++)
						groupCCEscolar.getChildren()[i].setEnabled(true);
				} else if(Integer.parseInt(evento.get(0).get(9))==BBDD.idTipoCitaConTutores) {
					groupCitaTutores.setEnabled(true);
					textCitaTutoresRelacion.setText(eventoTipo.get(0).get(1));
					Vector<String> estudiantesCita = BBDD.consultarIdEstudiantesCitaTutores(evento.get(0).get(0));
					listConIdCitaTutoresEstudiantes.seleccionarIds(estudiantesCita);
					for (int i=0;i<groupCitaTutores.getChildren().length;i++)
						groupCitaTutores.getChildren()[i].setEnabled(true);
				} else if(Integer.parseInt(evento.get(0).get(9))==BBDD.idTipoETCP) {
				} else if(Integer.parseInt(evento.get(0).get(9))==BBDD.idTipoOtroTipo) {
					groupOtro.setEnabled(true);
					textAreaOtroDescripcion.setText(eventoTipo.get(0).get(1));
					for (int i=0;i<groupOtro.getChildren().length;i++)
						groupOtro.getChildren()[i].setEnabled(true);
				}
			}
		}
		if (listConIdEventos.idSeleccionado()==null){
			buttonBorrar.setEnabled(false);
		} else {
			buttonBorrar.setEnabled(true);
		}
	}
	public void seleccionarEvento(String idEvento){
		checkBoxPasado.setSelection(true);
		comboConIdTipo.seleccionarId(String.valueOf(BBDD.idTipoTodos));
		actualizarListaEventos(idEvento);
	}
}
